%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc

Summary:                An Open Source implementation of the Java Transaction Service
Name:                   tyrex
Version:                1.0.3
Release:                1jpp
Epoch:                  0
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
Group:                  Development/Tools
License:                BSD-like
Url:                    http://tyrex.sourceforge.net
BuildArch:              noarch
BuildRequires:          jpackage-utils >= 0:1.7.4
BuildRequires:          java-devel = 0:1.5.0
BuildRequires:          ant >= 0:1.6.5
BuildRequires:          ant-trax
BuildRequires:          avalon-framework
BuildRequires:          avalon-logkit
BuildRequires:          castor0
BuildRequires:          j2ee-connector
BuildRequires:          java-devel = 0:1.5.0
BuildRequires:          javamail
BuildRequires:          jta_1_0_1B_api
BuildRequires:          jts >= 0:1.0-5jpp
BuildRequires:          junit
BuildRequires:          ldapsdk
BuildRequires:          log4j
BuildRequires:          openorb >= 0:1.4.0-3jpp
BuildRequires:          openorb-tns
BuildRequires:          xalan-j2
BuildRequires:          xalan-j2-xsltc
BuildRequires:          xerces-j2
BuildRequires:          xml-commons-apis
Source0:                http://prdownloads.sourceforge.net/tyrex/%{name}-%{version}-src.tgz
Source1:                tyrex-1.0.3.pom
Patch0:                 tyrex-1.0.3-build.patch
Patch1:                 tyrex-1.0.3-Current.patch
Patch2:                 tyrex-1.0.3-OTSTest.patch
BuildRoot:              %{_tmppath}/%{name}-%{version}-%{release}-root
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3


%description
Tyrex is a J2EE service provider for both Servlet
and EJB container, JMS providers and generic connectors. 
It provides services for security and authentication,
local and distributed transactions, resource configuration
and pooling, and TP monitoring. 
- Full support for JTA and OTS transactions APIs 
- Support for local and distributed transactions 
- JAAS-based authentication, LDAP login module 
- Configurable transaction processing monitor 
- JDBC pooling and automatic JDBC resource enlistment 
- JCA connection manager 
- XML based configuration 
- JNDI environment naming context 
- Transaction context propagation over IIOP 
- Can be used as a stand alone OTS server 

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
%setup -q
# remove external jars
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
for j in $(find src -name "*.java" -exec grep -l 'assert *(' {} \;); do
    sed -i -e 's:assert *(:assertTrue(:' $j
done
for j in $(find src -name "*.java" -exec grep -l '\.PI\.' {} \;); do
    sed -i -e 's:\.PI\.:\.orb\.pi\.:g' $j
done
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0
export OPT_JAR_LIST="ant/ant-trax"
export CLASSPATH=$(build-classpath \
castor0 \
commons-logging \
avalon-framework \
avalon-logkit \
geronimo-corba-1.0-apis \
geronimo-javamail-1.3.1-api \
geronimo-j2ee-connector-1.5-api \
jts \
jta_1_0_1B_api \
junit \
log4j \
openorb/orb \
openorb/orb-omg \
openorb/orb-tools \
openorb/tns \
openorb/tools \
)
CLASSPATH=$CLASSPATH:build/classes:build/tests

#export OPT_JAR_LIST="ant/ant-trax"
ant -Dbuild.sysclasspath=only -f src/build.xml all-iiop doc javadoc

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}
install -m 644 dist/%{name}-%{version}-iiop.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-iiop-%{version}.jar
install -m 644 dist/%{name}-%{version}-iiop-tests.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-iiop-tests-%{version}.jar
install -m 644 dist/%{name}-%{version}-tests.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-tests-%{version}.jar
install -m 644 dist/%{name}-%{version}-tests-unit.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-tests-unit-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/schema
install -m 644 build/schema/* \
        $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/schema

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -prf build/doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf build/doc/javadoc

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -prf build/doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%doc %{_docdir}/%{name}-%{version}/license.txt
%{_javadir}/*.jar
%{_datadir}/%{name}-%{version}
%{_datadir}/maven2
%{_mavendepmapfragdir}

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Wed Jan 30 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0.3-1jpp
- 1.0.3
- Add -iiop, add one pom and depmap frag

* Sat Mar 05 2005 Ralph Apel <r.apel at r-apel.de> 1.0.1-3jpp
- Specify ant-trax build requirement

* Tue Sep 28 2004 Ralph Apel <r.apel at r-apel.de> 1.0.1-2jpp
- Replace Copyright: tag by License:
- State requirement versions with Epoch
- Replace jndi, jdbc-stdext, jsse-ext, jaas-ext requirements with
  java >= 0:1.4
- Replace all other external dependencies with JPackage stuff
- Do generate manual and add -manual subpackage
- Add /usr/share/tyrex-1.0.1/schema to main package

* Fri Sep 03 2004 Fernando Nasser <fnasser@redhat.com> 1.0.1-1jpp
- Upgrade to 1.0.1
- Rebuilt with Ant 1.6.2

* Fri May 16 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0-3jpp
- Rebuild with external castor

* Wed Mar 26 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0-2jpp
- For jpackage-utils 1.5

* Mon Jan 21 2002 Henri Gomez <hgomez@slib.fr> 0.9.7.0-1jpp
- Initial jpp release
- will require a later rebuild against to be created package :
  castor-xml.jar, jaas.jar, jtf-0.1.jar, jts.jar, ldapjdk.jar, ots.jar, utils-0.5.jar

* Fri Nov 16 2001 Henri Gomez <hgomez@slib.fr>
- tyrex 0.9.7 RPM release 2
- rebuild with jikes 1.15

* Tue Oct 02 2001 Henri Gomez <hgomez@slib.fr>
- tyrex 0.9.7
- Initial release 
- XML documentation couldn't be generated using latest ant/xalan
- jikes 1.15 couldn't be used and reports many errors

